package easyaction;

import java.io.IOException;

import javax.servlet.Filter;
import javax.servlet.FilterChain;
import javax.servlet.FilterConfig;
import javax.servlet.ServletException;
import javax.servlet.ServletRequest;
import javax.servlet.ServletResponse;

/**
 * GR[fBOtB^łBGR[h̐ݒweb.xml
 *  &lt;param-value&gt;Windows-31J&lt;/param-value&gt;
 *  ̂悤ɂĂB
 * @author hyamag
 *
 */
public class CharacterEncodingFilter implements Filter {
    protected String _encoding = null;
    protected FilterConfig _filterConfig = null;
    protected boolean _ignore = true;

    public void destroy() {
        _encoding = null;
        _filterConfig = null;
	}

	public void doFilter(ServletRequest request, ServletResponse response, FilterChain chain)
	throws IOException, ServletException {
		// Conditionally select and set the character encoding to be used
		if (_ignore || (request.getCharacterEncoding() == null)) {
			String encoding = selectEncoding(request);
			if (encoding != null)
				request.setCharacterEncoding(encoding);
		}
		// Pass control on to the next filter
		chain.doFilter(request, response);
	}

	public void init(FilterConfig filterConfig) throws ServletException {
        _filterConfig = filterConfig;
        _encoding = _filterConfig.getInitParameter("encoding");
        String value = _filterConfig.getInitParameter("ignore");

        if (value == null)
        	_ignore = true;
        else if (value.equalsIgnoreCase("true"))
        	_ignore = true;
        else if (value.equalsIgnoreCase("yes"))
        	_ignore = true;
        else
        	_ignore = false;
	}
	
    protected String selectEncoding(ServletRequest request) {
    	return (_encoding);
    }
}
